#include <iostream>
#include <fstream>
#include <vector>
#define rep(i,a,b) for(int i=a;i<b;++i)
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef float fl;

vvi adj;
int n_v, n_e;


void print(vvi&t) {
	rep(i,0,t.size()) {
		rep(j,0,t[i].size()) {
			cout << t[i][j] << ' ';
		}
		cout << endl;
	}
}

void r_G(string path) {
	ifstream file(path.c_str());
	file >> n_v >> n_e;
	adj = vvi(n_v, vi(n_v, 0));
	rep(T,0,n_e) {
		int x,y;
		file >> x >> y;
		adj[x][y]=adj[y][x] = 1;
	}
	file.close();
}

vvi count(bool ao = true) {
	vvi ans_ao(n_v, vi(n_v, 0));
	vvi ans_o(n_v, vi(n_v, 0)); 
	int total=0;
//	cout << "start with "<<endl;print(adj);
	rep(t,0,1<<n_e) {
		vvi ori(adj);
		int k = 0;
		rep(i,0,n_v) {
			ori[i][i] = 0;
			rep(j,i+1,n_v) {
				if(adj[i][j]) {
					if(t & (1<<k))
						{ori[i][j] = 1; ori[j][i] = 0;}
					else
						{ori[j][i] = 1; ori[i][j] = 0;}
					++k;
				}
			}
		}
//		cout << "now, consider " << endl;print(ori);

		int MUCH = 1<<28;
		rep(i,0,n_v)rep(j,0,n_v)if(ori[i][j] == 0)ori[i][j] = MUCH;
		rep(k,0,n_v)rep(i,0,n_v)rep(j,0,n_v)
			ori[i][j] = min(ori[i][j], ori[i][k] + ori[k][j]);
		bool acyclic = true;
		rep(i,0,n_v) if(ori[i][i] < MUCH) {acyclic = false; break;}
		
		if(acyclic) {
			++ans_ao[0][0];
			rep(i,0,n_v)rep(j,0,n_v)if(i!=j && ori[i][j]<MUCH) ++ans_ao[i][j];
		}
		++ans_o[0][0];
		rep(i,0,n_v)rep(j,0,n_v)if(i!=j && ori[i][j]<MUCH) ++ans_o[i][j];
		
		rep(i,0,n_v)rep(j,0,n_v)if(ori[i][j] == MUCH)ori[i][j] = 9;
		

		/*cout << "Becomes " << endl;		print(ori);
		cout<<"it's ";if(!acyclic)cout <<"not ";cout<< "acyclic." << endl;*/
	}
	if(ao)
	return ans_ao;
	else
	return ans_o;
}

fl ao(int a, int b) {
	vvi ans = count(); return fl(ans[a][b])/fl(ans[0][0]);
}

fl o(int a, int b) {
	vvi ans = count(false); return fl(ans[a][b])/fl(ans[0][0]);
}

int main(int argc, char **argv) {
	if(argc > 1) r_G(argv[1]);
	else r_G("gr3.txt");
/*
	//rep(a,0,n_v) rep(b,0,n_v) if(a != b)
	cout << "AO: " << ao(0,2) << endl;
	cout << "O:  " <<  o(0,2) << endl;
*/
	{
		vvi ans = count(false);
		int a = 0, b = 1;
		int A = ans[a][b];
		int B = ans[0][0];
		fl x = fl(A)/fl(B);
		cout << a << " -> " << b << " : " << A << " / " << B << " : " << x << endl;
	}
	
	
	return 0;
}
